(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-reactive-form', ['exports', '@angular/forms', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-reactive-form'] = {}, global.ng.forms, global.ng.core));
}(this, function (exports, forms, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} factory
     * @param {?=} destroy
     * @return {?}
     */
    function lazy(factory, destroy) {
        /** @type {?} */
        var init = false;
        /** @type {?} */
        var lVal;
        /** @type {?} */
        var err;
        /**
         * @return {?}
         */
        function value() {
            if (!init) {
                init = true;
                try {
                    lVal = factory();
                }
                catch (e) {
                    err = e;
                }
            }
            if (err) {
                throw err;
            }
            return lVal;
        }
        value.reset = (/**
         * @return {?}
         */
        function () {
            if (init) {
                err = undefined;
                if (typeof destroy === 'function') {
                    destroy(lVal);
                }
                init = false;
            }
        });
        value.isInit = (/**
         * @return {?}
         */
        function () { return init; });
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} control
     * @param {...?} ps
     * @return {?}
     */
    function traverseControl(control) {
        var ps = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            ps[_i - 1] = arguments[_i];
        }
        if (ps.length === 0 || !control) {
            return control;
        }
        if (control instanceof forms.FormGroup || control instanceof forms.FormArray) {
            var _a = __read(ps), p = _a[0], lps = _a.slice(1);
            return traverseControl.apply(void 0, __spread([control.controls[p]], lps));
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} ctrls
     * @return {?}
     */
    function getElements(ctrls) {
        return Array.isArray(ctrls) ? ctrls :
            typeof ctrls === 'object' && Object.values(ctrls) || [];
    }
    /**
     * @param {?} root
     * @param {?} action
     * @param {?} updateState
     * @return {?}
     */
    function tapControls(root, action, updateState) {
        var e_1, _a;
        try {
            for (var _b = __values(getElements(root && root.controls)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var ctrl = _c.value;
                if (ctrl instanceof forms.FormGroup || ctrl instanceof forms.FormArray) {
                    tapControls(ctrl, action, updateState);
                    continue;
                }
                if (typeof action === 'function') {
                    action(ctrl);
                }
                if (updateState) {
                    ctrl.updateValueAndValidity();
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} items
     * @return {?}
     */
    function uniq(items) {
        return (items || []).filter((/**
         * @param {?} val
         * @param {?} idx
         * @param {?} self
         * @return {?}
         */
        function (val, idx, self) { return val && self.indexOf(val) === idx; }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DependentValidatorBuilderImpl = /** @class */ (function () {
        function DependentValidatorBuilderImpl(affectedControls, validate) {
            this.affectedControls = affectedControls;
            this.validate = validate;
        }
        /**
         * @return {?}
         */
        DependentValidatorBuilderImpl.prototype.inverse = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new DependentValidatorBuilderImpl(this.affectedControls, (/**
             * @return {?}
             */
            function () { return !_this.validate(); }));
        };
        return DependentValidatorBuilderImpl;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */
    DependentValidatorBuilderRootImpl = /** @class */ (function () {
        function DependentValidatorBuilderRootImpl(form) {
            this.form = form;
        }
        /**
         * @param {...?} builders
         * @return {?}
         */
        DependentValidatorBuilderRootImpl.prototype.all = /**
         * @param {...?} builders
         * @return {?}
         */
        function () {
            var builders = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                builders[_i] = arguments[_i];
            }
            return new DependentValidatorBuilderImpl((/**
             * @return {?}
             */
            function () { return uniq([].concat(builders.map((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.affectedControls(); })))); }), (/**
             * @return {?}
             */
            function () { return builders.every((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.validate(); })); }));
        };
        /**
         * @param {...?} builders
         * @return {?}
         */
        DependentValidatorBuilderRootImpl.prototype.any = /**
         * @param {...?} builders
         * @return {?}
         */
        function () {
            var builders = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                builders[_i] = arguments[_i];
            }
            return new DependentValidatorBuilderImpl((/**
             * @return {?}
             */
            function () { return uniq([].concat(builders.map((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.affectedControls(); })))); }), (/**
             * @return {?}
             */
            function () { return builders.some((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.validate(); })); }));
        };
        /**
         * @param {?} predicate
         * @param {?} firstPath
         * @param {...?} paths
         * @return {?}
         */
        DependentValidatorBuilderRootImpl.prototype.validator = /**
         * @param {?} predicate
         * @param {?} firstPath
         * @param {...?} paths
         * @return {?}
         */
        function (predicate, firstPath) {
            var _this = this;
            var paths = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                paths[_i - 2] = arguments[_i];
            }
            /** @type {?} */
            var formFn = lazy((/**
             * @return {?}
             */
            function () { return _this.form(); }));
            /** @type {?} */
            var ctrlFn = lazy((/**
             * @return {?}
             */
            function () {
                if (typeof firstPath === 'string' || typeof firstPath === 'number') {
                    return traverseControl.apply(void 0, __spread([formFn(), firstPath], paths));
                }
                else if (typeof firstPath === 'function') {
                    return firstPath(formFn());
                }
            }));
            return new DependentValidatorBuilderImpl((/**
             * @return {?}
             */
            function () { return [ctrlFn()]; }), (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var ctrl = ctrlFn();
                return ctrl && typeof predicate === 'function' && predicate(ctrl.value, formFn());
            }));
        };
        return DependentValidatorBuilderRootImpl;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */
    DependentValidatorImpl = /** @class */ (function () {
        function DependentValidatorImpl(rootFn, builderFn) {
            var _this = this;
            this.rootFn = rootFn;
            this.builderFn = builderFn;
            this.builder = lazy((/**
             * @return {?}
             */
            function () {
                if (typeof _this.builderFn === 'function') {
                    /** @type {?} */
                    var builderRoot = new DependentValidatorBuilderRootImpl((/**
                     * @return {?}
                     */
                    function () { return _this.rootFn(); }));
                    return _this.builderFn(builderRoot);
                }
            }));
            this.subscribedControls = [];
            this.subscription = lazy((/**
             * @return {?}
             */
            function () {
                return _this.builder().affectedControls()
                    .filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return !!item; })).map((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item
                    .valueChanges.subscribe((/**
                 * @return {?}
                 */
                function () { return _this.subscribedControls
                    .forEach((/**
                 * @param {?} control
                 * @return {?}
                 */
                function (control) { return control.updateValueAndValidity(); })); })); }));
            }), (/**
             * @param {?} subs
             * @return {?}
             */
            function (subs) { return subs.forEach((/**
             * @param {?} s
             * @return {?}
             */
            function (s) { return s.unsubscribe(); })); }));
        }
        /**
         * @return {?}
         */
        DependentValidatorImpl.prototype.reset = /**
         * @return {?}
         */
        function () {
            this.builder.reset();
            this.subscription.reset();
        };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} path
         * @param {...?} validators
         * @return {THIS}
         */
        DependentValidatorImpl.prototype.applyValidator = /**
         * @template THIS
         * @this {THIS}
         * @param {?} path
         * @param {...?} validators
         * @return {THIS}
         */
        function (path) {
            var validators = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                validators[_i - 1] = arguments[_i];
            }
            /** @type {?} */
            var paths = Array.isArray(path) ? path : [path];
            /** @type {?} */
            var ctrl = traverseControl.apply(void 0, __spread([(/** @type {?} */ (this)).rootFn()], paths));
            if (ctrl) {
                ctrl.setValidators((/** @type {?} */ (this)).createValidator.apply((/** @type {?} */ (this)), __spread(validators)));
            }
            return (/** @type {?} */ (this));
        };
        /**
         * @param {...?} validators
         * @return {?}
         */
        DependentValidatorImpl.prototype.createValidator = /**
         * @param {...?} validators
         * @return {?}
         */
        function () {
            var _this = this;
            var validators = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                validators[_i] = arguments[_i];
            }
            /** @type {?} */
            var validate = forms.Validators.compose(validators);
            /** @type {?} */
            var ctrlSubscribed = false;
            return (/**
             * @param {?} ctrl
             * @return {?}
             */
            function (ctrl) {
                /** @type {?} */
                var builder;
                if (!ctrlSubscribed) {
                    ctrlSubscribed = true;
                    if (_this.subscribedControls.indexOf(ctrl) === -1) {
                        _this.subscribedControls.push(ctrl);
                    }
                }
                if (!_this.subscription.isInit() && _this.rootFn()) {
                    builder = _this.builder();
                    _this.subscription();
                }
                else if (_this.builder.isInit()) {
                    builder = _this.builder();
                }
                return (!builder || builder.validate()) ? validate(ctrl) : null;
            });
        };
        return DependentValidatorImpl;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    FormUtils = /** @class */ (function () {
        function FormUtils(rootFn) {
            var _this = this;
            this.rootFn = rootFn;
            this._root = lazy((/**
             * @return {?}
             */
            function () {
                if (_this.rootFn instanceof forms.FormGroup || _this.rootFn instanceof forms.FormArray) {
                    return _this.rootFn;
                }
                else if (typeof _this.rootFn === 'function') {
                    return _this.rootFn();
                }
            }));
        }
        Object.defineProperty(FormUtils.prototype, "root", {
            get: /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var r = this._root;
                if (!r()) {
                    r.reset();
                }
                return (/** @type {?} */ (r()));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?=} action
         * @param {?=} updateState
         * @return {?}
         */
        FormUtils.prototype.tapControls = /**
         * @param {?=} action
         * @param {?=} updateState
         * @return {?}
         */
        function (action, updateState) {
            if (updateState === void 0) { updateState = true; }
            tapControls(this.root, action, updateState);
        };
        /**
         * @param {?} builderFn
         * @return {?}
         */
        FormUtils.prototype.createDependentValidator = /**
         * @param {?} builderFn
         * @return {?}
         */
        function (builderFn) {
            var _this = this;
            return new DependentValidatorImpl((/**
             * @return {?}
             */
            function () { return _this.root; }), builderFn);
        };
        /**
         * @return {?}
         */
        FormUtils.prototype.makePristine = /**
         * @return {?}
         */
        function () {
            this.tapControls((/**
             * @param {?} ctrl
             * @return {?}
             */
            function (ctrl) {
                ctrl.markAsPristine();
                ctrl.markAsUntouched();
            }));
        };
        /**
         * @return {?}
         */
        FormUtils.prototype.makeDirty = /**
         * @return {?}
         */
        function () {
            this.tapControls((/**
             * @param {?} ctrl
             * @return {?}
             */
            function (ctrl) {
                ctrl.markAsDirty();
                ctrl.markAsTouched();
            }));
        };
        return FormUtils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */
    ExtendedFormBuilderResult = /** @class */ (function () {
        function ExtendedFormBuilderResult(fb, factory) {
            var _this = this;
            this.fb = fb;
            this.factory = factory;
            this.validators = [];
            this._formUtils = lazy((/**
             * @return {?}
             */
            function () { return new FormUtils((/**
             * @return {?}
             */
            function () { return _this.form; })); }));
            this.form = this.factory(this.fb, (/**
             * @param {?} dv
             * @return {?}
             */
            function (dv) {
                /** @type {?} */
                var v = _this.formUtils.createDependentValidator(dv);
                _this.validators.push(v);
                return v;
            }));
        }
        Object.defineProperty(ExtendedFormBuilderResult.prototype, "formUtils", {
            get: /**
             * @return {?}
             */
            function () {
                return this._formUtils();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ExtendedFormBuilderResult.prototype.updateValidators = /**
         * @return {?}
         */
        function () {
            this.validators.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.reset(); }));
            this.formUtils.tapControls();
        };
        return ExtendedFormBuilderResult;
    }());
    var ExtendedFormBuilder = /** @class */ (function () {
        function ExtendedFormBuilder(fb) {
            this.fb = fb;
        }
        /**
         * @template T
         * @param {?} factory
         * @return {?}
         */
        ExtendedFormBuilder.prototype.build = /**
         * @template T
         * @param {?} factory
         * @return {?}
         */
        function (factory) {
            return new ExtendedFormBuilderResult(this.fb, factory);
        };
        ExtendedFormBuilder.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ExtendedFormBuilder.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        return ExtendedFormBuilder;
    }());

    exports.ExtendedFormBuilder = ExtendedFormBuilder;
    exports.FormUtils = FormUtils;
    exports.tapControls = tapControls;
    exports.traverseControl = traverseControl;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-reactive-form.umd.js.map
