import { FormArray, FormBuilder, FormGroup } from '@angular/forms';
import { DependentValidator, DependentValidatorBuilderFactory, DependentValidatorFactory } from './declarations';
import { FormUtils } from './form-utils';
export declare class ExtendedFormBuilderResult<T extends FormGroup | FormArray> {
    private fb;
    private factory;
    private validators;
    private _formUtils;
    readonly form: T;
    readonly formUtils: FormUtils<T>;
    constructor(fb: FormBuilder, factory: (fb: FormBuilder, dp: (builderFn: DependentValidatorBuilderFactory<T>) => DependentValidator) => T);
    updateValidators(): void;
}
export declare class ExtendedFormBuilder {
    private fb;
    constructor(fb: FormBuilder);
    build<T extends FormGroup | FormArray>(factory: (fb: FormBuilder, dependentValidatorFactory: DependentValidatorFactory<T>) => T): ExtendedFormBuilderResult<T>;
}
